`timescale 1ns / 1ps
//*****************************************************************************
// File Name            : da_e_pwm_ch.v
//-----------------------------------------------------------------------------
// Function             : exp^da -> pwm  1ch
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo 
//-----------------------------------------------------------------------------
// History
// -.-- 2013/01/10 
//*****************************************************************************
module da_e_pwm_ch(
  input clk,
  input reset_n,
  input [3:0]din,
  output reg pwm
);

reg [5:0] count;
reg [5:0]pulse_end_cnt;


always @(posedge clk or negedge reset_n) begin
  if( !reset_n ) 
    count<=0;
  else
    count <= count + 6'd1;
end	
	
always @(posedge clk) begin
	case (din)
		4'd1: pulse_end_cnt <=6'd0;
		4'd2: pulse_end_cnt <=6'd0;
		4'd3: pulse_end_cnt <=6'd0;
		4'd4: pulse_end_cnt <=6'd1;
		4'd5: pulse_end_cnt <=6'd1;
		4'd6: pulse_end_cnt <=6'd2;
		4'd7: pulse_end_cnt <=6'd3;
		4'd8: pulse_end_cnt <=6'd5;
		4'd9: pulse_end_cnt <=6'd7;
		4'd10: pulse_end_cnt <=6'd10;
		4'd11: pulse_end_cnt <=6'd15;
		4'd12: pulse_end_cnt <=6'd22;
		4'd13: pulse_end_cnt <=6'd31;
		4'd14: pulse_end_cnt <=6'd44;
		4'd15: pulse_end_cnt <=6'd63;
		default: pulse_end_cnt <=6'd0;
	endcase
end		   
	
always @(posedge clk or negedge reset_n) begin
  if( !reset_n ) 
    pwm<=1'b0;
  else
    if(din==4'b0)
      pwm<=1'b0;
	else if(count==6'd63)
      pwm<=1'b1;
	else if(count==pulse_end_cnt)
      pwm<=1'b0;
	else
	  pwm <= pwm;
end

endmodule
